#-------------------------------------------------------------------------------
# Name:        
# Purpose:     Estimates recomb for different distances in D. sim data
#-------------------------------------------------------------------------------

import sys
import numpy

chrom = sys.argv[1]
start = int(sys.argv[2])
end = start+100000
increment=200000
minCC=100
tiny=1e-5

maxcat=int(numpy.log10(float(end+increment-start)))

distribution=[[[[0 for y in range(11)] for x in range(k+1)] for k in range(26)] for j in range(maxcat+1)]


out1  =open(chrom+"."+sys.argv[2]+".tab.txt", "w")
out2  =open(chrom+"."+sys.argv[2]+".perfect.distant.txt", "w")

pos=[]
bigmat=[]

nsps1=0
src  =open("nuz"+chrom+".vcf", "rU")
for line_idx, line in enumerate(src):
	cols = line.replace('\n', '').split('\t') 
# 2L	334	.	T	G	7706.99	.	
	if cols[0]==chrom and len(cols[4])==1:
		position=int(cols[1])
		if position<start:
			pass
		elif position >=start and position < (end+increment):
			genos=[]
			px=[0,0]
			for j in range(18,200): # Sz samples

				# 0/0:4,0:4:12:0,12,180
				info=cols[j].split(":")
				if info[0]=="0/0":
					genos.append(0)
					px[0]+=1
				elif info[0]=="1/1":
					genos.append(1)
					px[1]+=1
				else:
					genos.append(-9)

			if (px[0]+px[1])>=minCC and px[0]>0 and px[1]>0:
				bigmat.append(genos)
				pos.append(position)
				if position >=start and position < end:
					nsps1+=1

		else:
			break

src.close()


nsps2=len(pos)


for i in range(nsps1): # snps in interval
	for j in range(i+1,nsps2):
		x=[0,0,0,0]
		for k in range(172):
			if bigmat[i][k]==0 and bigmat[j][k]==0:
				x[0]+=1
			elif bigmat[i][k]==1 and bigmat[j][k]==0:
				x[1]+=1
			elif bigmat[i][k]==0 and bigmat[j][k]==1:
				x[2]+=1
			elif bigmat[i][k]==1 and bigmat[j][k]==1:
				x[3]+=1
		nx=x[0]+x[1]+x[2]+x[3]

		if nx>=minCC:
			pr1=float(x[0]+x[2])/float(nx)
			pr2=float(x[0]+x[1])/float(nx)

			if pr1*(1-pr1)>0 and pr2*(1-pr2)>0:
				dist=pos[j]-pos[i]
				dcat=int(numpy.log10(float(dist)))

				if pr1<=0.5 and pr2<=0.5:
					n1=int( 50.0*max(pr1,pr2)+tiny )
					n2=int( 50.0*min(pr1,pr2)+tiny )
					if x[0]==0:
						n3=0
					elif x[0]>= nx*(min(pr1,pr2))-tiny:
						n3=10
					else:
						dmin=-pr1*pr2
						dmax=min(pr1,pr2)*(1-max(pr1,pr2))
						dobs=x[0]/float(nx)-pr1*pr2
						if dobs>dmin and dobs<dmax:
							n3 = int(10*(dobs-dmin)/(dmax-dmin))
						else:
							print ("ugh",x,dmin,dmax,dobs,n3)
					
				elif pr1<=0.5 and pr2>0.5:
					n1=int( 50.0*max(pr1,1-pr2)+tiny )
					n2=int( 50.0*min(pr1,1-pr2)+tiny )
					if x[2]==0:
						n3=0
					elif x[2]>= nx*(min(pr1,1-pr2))-tiny:
						n3=10
					else:
						dmin=-pr1*(1-pr2)
						dmax=min(pr1,1-pr2)*(1-max(pr1,1-pr2))
						dobs=x[2]/float(nx)-pr1*(1-pr2)
						n3 = int(10.0*(dobs-dmin)/(dmax-dmin))
				elif pr1>0.5 and pr2<=0.5:
					n1=int( 50.0*max(1-pr1,pr2)+tiny )
					n2=int( 50.0*min(1-pr1,pr2)+tiny )
					if x[1]==0:
						n3=0
					elif x[1]>= nx*(min(1-pr1,pr2))-tiny:
						n3=10
					else:
						dmin=-(1-pr1)*pr2
						dmax=min(1-pr1,pr2)*(1-max(1-pr1,pr2))
						dobs=x[1]/float(nx)-(1-pr1)*pr2
						n3 = int(10*(dobs-dmin)/(dmax-dmin))
				elif pr1>0.5 and pr2>0.5:
					n1=int( 50.0*max(1.0-pr1,1.0-pr2)+tiny )
					n2=int( 50.0*min(1.0-pr1,1.0-pr2)+tiny )
					if x[3]==0:
						n3=0
					elif x[3]>= nx*(min(1-pr1,1-pr2))-tiny:
						n3=10
					else:
						dmin=-(1-pr1)*(1-pr2)
						dmax=min(1-pr1,1-pr2)*(1-max(1-pr1,1-pr2))
						dobs=x[3]/float(nx)-(1-pr1)*(1-pr2)
						n3 = int(10*(dobs-dmin)/(dmax-dmin))
				else:
					print ("confused ",pr1,pr2,x)
				# print pr1,pr2,x,dcat,n1,n2,n3
				distribution[dcat][n1][n2][n3]+=1

				if dcat==maxcat and n3==10 and n2>10 and n1 > 10:
					out2.write(str(x)+'\n')
					out2.write(str(i)+'\t'+str(pos[i]))
					for k in range(172):
						out2.write('\t'+str(bigmat[i][k]))
					out2.write('\n')
					out2.write(str(j)+'\t'+str(pos[j]))
					for k in range(172):
						out2.write('\t'+str(bigmat[j][k]))
					out2.write('\n\n')



for j in range(maxcat+1):
	for k in range(26):
		for x in range(k+1):
			for y in range(11):
				out1.write(str(j)+'\t'+str(k)+'\t'+str(x)+'\t'+str(y)+'\t'+str(distribution[j][k][x][y])+'\n')




