#-------------------------------------------------------------------------------
# Name:        
# Purpose:     processes "tab.txt" output from LD.analysis1.py
# separate outputs for varscan and gatk
#-------------------------------------------------------------------------------

import sys
import numpy

chrom = sys.argv[1]
start = int(sys.argv[2])
end = start+100000
increment=100000
minCC=100
tiny=1e-5


maxcat=int(numpy.log10(float(end+increment-start)))

out1  =open(chrom+"."+sys.argv[2]+".summary.txt", "w") # 2L.20500000.tab.txt


r2p={}
for j in range(maxcat+1):
	r2p[j]={}
	for k in range(26):
		r2p[j][k]={}
		for x in range(100):
			r2p[j][k][x]=0


meanr2={}
for j in range(maxcat+1):
	meanr2[j]=[0,0.0]

nsps1=0
src  =open(chrom+"."+sys.argv[2]+".tab.txt", "rU")
for line_idx, line in enumerate(src):
        cols = line.replace('\n', '').split('\t') 
# 0	0	0	0	5	
	dcat=int(cols[0])
	p1=0.01+float(cols[1])/50.0
	p2=0.01+float(cols[2])/50.0
	if p1>0.5:
		p1=0.5
	if p2>0.5:
		p2=0.5
	Rcat=int(cols[3])
	if Rcat==0:
		D = -p1*p2
	elif Rcat==10:
		D = p2*(1-p1)
	else:
		dmin=-p1*p2
		dmax=p2*(1-p1)
		D = dmin + float(Rcat)*(dmax-dmin)/ 10.0

	r2=(D*D)/(p1*(1-p1)*p2*(1-p2))
	r2cat=int(100.0*r2)
	if r2cat>99:
		r2cat=99

	r2p[dcat][int(cols[1])][r2cat]+=int(cols[4])
	if r2>1:
		r2=1.0 # print cols,D,p1,p2,r2
	if p1>0.1 and p2>0.1:
		meanr2[dcat][0]+=int(cols[4])
		meanr2[dcat][1]+=( float(cols[4])*r2 )
 

src.close()


for j in range(maxcat+1):
	if meanr2[j][0] > 0:
		meanr2[j][1]=meanr2[j][1]/float(meanr2[j][0])
		print start, "dcat ",j,meanr2[j][0]," mean r2 ",meanr2[j][1]
	else:
		print start, "dcat ",j,meanr2[j][0]

	for k in range(26):
		p1=0.01+float(k)/50.0
		for x in range(100):
			out1.write(str(j)+'\t'+str(k)+'\t'+str(p1)+'\t'+str(x)+'\t'+str(r2p[j][k][x])+'\n')





